#include <iostream>

using namespace std;

class HotDrink {
protected:
    float costAmount;
public:
     virtual void boilWater() = 0;
     virtual void addBaseIngredient() = 0;
     virtual void prepare() = 0;
     virtual void addExtraIngredient() = 0;
     float getCostAmount() // joogi valmistusmaksumuse
     {
         return costAmount;
     }
    float getProfitAmount() // kaupmehe poolt vetava mgikatte e. kasumi
    {
        return 0.5 * getCostAmount();
    }
    float getSalesAmount()  // summa, palju klient peaks maksma (maksumus + kasum)
    {
        return getCostAmount() + getProfitAmount();
    }
};
class Tea : public HotDrink {
public:
    Tea()
    {
        costAmount = 0.4;
    }
     void boilWater() {
        cout << "Keedan vett" << endl;
    }
    void addBaseIngredient(){
        cout << "Pistan teepaki kuuma vette" << endl;
    }
    void prepare() {
        cout << "Valan teevee tassi" << endl;
    }
    void addExtraIngredient()  {
        cout << "Lisan sidrunit ja mett" << endl;
    }
};

class Coffee : public HotDrink {
public:
    Coffee()
    {
        costAmount = 0.5;
    }
    void boilWater() {
        cout << "Kuumutan vett 95C-ni" << endl;
    }
    void addBaseIngredient() {
        cout << "Panen kohvipulbri filtrisse" << endl;
    }
    void prepare() {
        cout << "Valan vee lbi filtri" << endl;
    }
    void addExtraIngredient() {
        cout << "Lisan suhkru ja koore" << endl;
    }
};


class Cocoa : public HotDrink {
public:
    Cocoa()
    {
        costAmount = 0.6;
    }
     void boilWater() {
        cout << "Keedan vett" << endl;
    }
    void addBaseIngredient(){
        cout << "Pistan kakaopulbri kuuma vette" << endl;
    }
    void prepare() {
        cout << "Valan kakao tassi" << endl;
    }
    void addExtraIngredient()  {
        cout << "Lisan suhkrut" << endl;
    }
};

enum DrinkType { TEA, COFFEE, COCOA };

class VendingMachine
{
    float totalprofit;
public:
    VendingMachine() { totalprofit = 0; }
    float getTotalProfit() { return totalprofit; }
    HotDrink *orderDrink(DrinkType dt)
    {
        HotDrink *ht = NULL;
        switch(dt)
        {
        case TEA:
            ht = new Tea;
            break;
        case COFFEE:
            ht = new Coffee;
            break;
        case COCOA:
            ht = new Cocoa;
            break;
        default:
            ;// ????
        }
        ht->boilWater();
        ht->addBaseIngredient();
        ht->prepare();
        ht->addExtraIngredient();

        totalprofit += ht->getProfitAmount();
        return ht;
    }
};
int main()
{
    VendingMachine v;
    HotDrink *t = v.orderDrink(TEA);
    cout << t->getCostAmount() << endl; // tee sidruni ja meega: 0.03+0.05+0.10+0.22
    // = 0.40
    cout << t->getSalesAmount() << endl; // klient peab maksma: 0.60

    //t = v.orderDrink(COFFEE);
 //   t->drink(); // kll on hea :)

    HotDrink *c = v.orderDrink(COFFEE);
    cout << c->getCostAmount() << endl; // kohv suhkru ja koorega: 0.03+0.25+0.07+0.15
    // = 0.50
    cout << c->getSalesAmount()<< endl; // klient peab maksma: 0.75

    t = v.orderDrink(COCOA);

    float totalprofit = v.getTotalProfit();
    cout << totalprofit << endl;   // kahe tellitud joogi peale kokku: 0.45

    return 0;
}
